﻿package com.JERsite{

	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.xml.XMLDocument;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.events.Event;
	import flash.display.Loader;
	import flash.filters.DropShadowFilter;
	import flash.filters.BevelFilter;
	import caurina.transitions.Tweener;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.Font;
	import flash.text.TextFieldAutoSize;
	import flash.media.Sound;

	public class imageLoader extends MovieClip {
		
		//Variables for holding XML data
		public var xmlLoader:URLLoader=new URLLoader;
		public var xmlData:XML;
		public var thumbNails:XMLList;
		//variables for holding projectButton class and and laying them out
		public var projectButtons:MovieClip = new MovieClip();
		public var buttnX:uint;
		public var buttnY:uint;
		public var buttnWidth:uint;
		public var buttnHeight:uint;
		public var projectFlag:String ="";
		public var projectSoundURL:String = "";
		//variables for holding thumbnails
		public var thumbContainer:MovieClip;
		public var thumbColumns:int;
		public var thumbX:int;
		public var thumbY:int;
		public var thumbWidth:int;
		public var totalImages:int;
		public var thumbSoundURL:String = "";
		public var thumbSound:Sound;
		//counters for thumbnails
		public var xCounter:int = 0;
		public var yCounter:int = 0;
		//loader for large images
		public var fullLoader:Loader = new Loader();
		public var finalLoader:Loader;
		public var finalLoaderX:int = 485;
		public var finalLoaderY:int = 6;
		//Text field objects
		public var textURL:String;
		public var descriptionField:cssProjectText;
		public var scroller:scrollBar;
		
		//PreLoader text field
		private var _percentInField:TextField = new TextField();
		private var _percentInFormat:TextFormat = new TextFormat();
		private var _gillSans:Font = new projectFontBold();
		
		//filters
		private var _upShadow:DropShadowFilter=new DropShadowFilter(8,330,0x001124,.8,6,6,.7);
		private var _inBevel:BevelFilter=new BevelFilter(7, 45, 0x001124, .8, 0x001124, .8, 5, 5, 1, 5, "inner", false);
		private var _upShadow2:DropShadowFilter=new DropShadowFilter(8,47,0x000000,.85,6,6,.7);

		//loads XML data and sends it to parsing functions. Adds MovieClip to stage for holding project buttons and listens for CLICKS.
		public function imageLoader() {
			xmlLoader.addEventListener(Event.COMPLETE,loadXML);//This adds a litener for the completion of
			xmlLoader.load(new URLRequest("Scripts/sculpture.xml"));//the loading of XML data. Once loaded the function gets called.

			addChild(projectButtons);
			projectButtons.addEventListener(MouseEvent.CLICK, layoutThumbs);
			projectButtons.buttonMode = true;
		}
		
		private function loadXML(e:Event):void {
			xmlData=new XML(e.target.data);
			parseXML(xmlData);
		}
		private function parseXML(galleryInput:XML) {
			//parsing
			buttnX = galleryInput.Buttons.@Xposition;
			buttnY = galleryInput.Buttons.@Yposition;
			buttnHeight = galleryInput.Buttons.@Height;
			projectSoundURL = galleryInput.Buttons.@sound;
			//more parsing
			thumbNails = galleryInput.Buttons;
			thumbX = thumbNails.Project[0].Thumbs.@Xposition;
			thumbY = thumbNails.Project[0].Thumbs.@Yposition;
			totalImages = thumbNails.Project[0].Thumbs.Image.length();
			thumbWidth = thumbNails.Project[0].Thumbs.@Width;
			thumbColumns = thumbNails.Project[0].Thumbs.@columns;
			thumbSoundURL = thumbNails.Project[0].Thumbs.@sound;
			createContainer();
			frontPageThumbs();

			var nameList:XMLList=galleryInput.Buttons.Project.@Name;

			for each (var nameElement:XML in nameList) {

				var projButton:projectButton = new projectButton(nameElement, projectSoundURL);

				projectButtons.addChild(projButton);
				projButton.name = nameElement;
				projButton.x = buttnX;
				projButton.y = buttnY;
				buttnY+=buttnHeight;
			}
		}
		//thumb container instantiator
		private function createContainer():void {

			thumbContainer = new MovieClip();
			thumbContainer.filters=[_upShadow];
			addChild(thumbContainer);
			thumbContainer.x = thumbX;
			thumbContainer.y = thumbY;
			thumbContainer.buttonMode = true;
			thumbSound = new Sound();
			thumbSound.load(new URLRequest(thumbSoundURL));
		}
		//loads the same set of images as the first projectButton would. Hard-coded to index[0]. Allows for something to be unloaded on first click.
		private function frontPageThumbs():void {
			
			projectFlag = thumbNails.Project[0].@Name;//Is an XML data telling flash which set of images is on

			projectButtons.removeEventListener(MouseEvent.CLICK, layoutThumbs);
			thumbContainer.addEventListener(MouseEvent.MOUSE_OVER, rotateThumb);
			thumbContainer.addEventListener(MouseEvent.MOUSE_OUT, deRotateThumb);
			thumbContainer.addEventListener(MouseEvent.MOUSE_OVER, thumbSoundPlay);
			
			for (var i:int = 0; i < totalImages; i++) {
				var thumbURLs = thumbNails.Project[0].Thumbs.Image[i].@thumb;
				var thumbLoader = new Loader();
				thumbLoader.load(new URLRequest(thumbURLs));
				thumbLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, thumbLoaded);
				thumbLoader.name = i;
				thumbLoader.x = (thumbWidth + 10) * xCounter;
				thumbLoader.y = (thumbWidth + 10) * yCounter;
				thumbLoader.alpha = .6;
				
				if (xCounter + 1 < thumbColumns) {
					xCounter++;
				} else {
					xCounter = 0;
					yCounter++;
				}
			}
			var fullURL = thumbNails.Project.(@Name == projectFlag).Thumbs.Image[0].@full;
			fullLoader.load(new URLRequest(fullURL));

			fullLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, fullLoaded);
			fullLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, displayPercent);
			fullLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, loaderOut);
			
			textURL = thumbNails.Project.(@Name == projectFlag).@blurb;
			descriptionField = new cssProjectText(textURL);
			addChild(descriptionField);
			descriptionField.x = 10;
			descriptionField.y = 385;
			
			scroller = new scrollBar();
			addChild(scroller);
			scroller.x = descriptionField.x + descriptionField.projectDescription.width + 15;
			scroller.y = descriptionField.y + 10;
			stage.addEventListener(MouseEvent.MOUSE_UP, onBallLoose);
			stage.addEventListener(Event.ENTER_FRAME, haltScroll);
			
			scroller.trackBall.addEventListener(MouseEvent.MOUSE_DOWN, onBallGrab);
			scroller.trackBall.addEventListener(MouseEvent.MOUSE_UP, onBallLoose);
			descriptionField.projectDescription.addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		//lays out thumbnails according to CLICKS
		private function layoutThumbs(e:MouseEvent):void {
			
			while(thumbContainer.numChildren) {
				thumbContainer.removeChildAt(0);
			}
			fullLoader.unload();
			projectButtons.removeEventListener(MouseEvent.CLICK, layoutThumbs);
			thumbContainer.removeEventListener(MouseEvent.MOUSE_UP, loadFullImage);
			
			totalImages = thumbNails.Project.(@Name == e.target.parent.name).Thumbs.Image.length();
			xCounter = 0;
			yCounter = 0;
			
			projectFlag = e.target.parent.name;
			
			for (var i:int = 0; i < totalImages; i++) {
				var thumbURLs = thumbNails.Project.(@Name == e.target.parent.name).Thumbs.Image[i].@thumb;
				var thumbLoader = new Loader();
				thumbLoader.load(new URLRequest(thumbURLs));
				thumbLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, thumbLoaded);
				thumbLoader.name = i;
				thumbLoader.x = (thumbWidth + 10) * xCounter;
				thumbLoader.y = (thumbWidth + 10) * yCounter;
				thumbLoader.alpha = .6;
				
				if (xCounter + 1 < thumbColumns) {
					xCounter++;
				} else {
					xCounter = 0;
					yCounter++;
				}
			}
			var fullURL = thumbNails.Project.(@Name == e.target.parent.name).Thumbs.Image[0].@full;
			fullLoader.load(new URLRequest(fullURL));
			fullLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, fullLoaded);
			
			textURL = thumbNails.Project.(@Name == projectFlag).@blurb;
			descriptionField.txtLoader.load(new URLRequest(textURL));
		}
		//listens for thumbnails to finish loading
		private function thumbLoaded(e:Event):void {
			var thumbButton:Loader = Loader(e.target.loader);
			thumbContainer.addChild(thumbButton);
		}
		//loads image after all data is in and places image.
		private function fullLoaded(e:Event):void {
			finalLoader = Loader (e.target.loader);
			finalLoader.filters=[_inBevel];
			addChild(finalLoader);
			finalLoader.x = finalLoaderX;
			finalLoader.y = finalLoaderY;
			
			if(finalLoader.width < 500) {
				var xPlacement:int = (500 - finalLoader.width)/2;
				finalLoader.x = finalLoaderX + xPlacement;
			}
			thumbContainer.addEventListener(MouseEvent.MOUSE_UP, loadFullImage);
			thumbContainer.addEventListener(MouseEvent.MOUSE_OVER, rotateThumb);
			thumbContainer.addEventListener(MouseEvent.MOUSE_OUT, deRotateThumb);
			projectButtons.addEventListener(MouseEvent.CLICK, layoutThumbs);
		}
		//loads/unloads large images
		private function loadFullImage(e:MouseEvent):void {
			thumbContainer.removeEventListener(MouseEvent.MOUSE_UP, loadFullImage);
			projectButtons.removeEventListener(MouseEvent.CLICK, layoutThumbs);
			
			fullLoader.unload();
			removeChild(finalLoader);
			var fullURL = thumbNails.Project.(@Name == projectFlag).Thumbs.Image[e.target.name].@full;
			fullLoader.load(new URLRequest(fullURL));
			fullLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, fullLoaded);
		}
		private function rotateThumb(e:MouseEvent):void {
			Tweener.addTween(e.target,{alpha:1,time:1,transition:"easeOutElastic"});
			Tweener.addTween(e.target,{scaleX:1.05,time:1,transition:"easeOutElastic"});
			Tweener.addTween(e.target,{scaleY:1.05,time:1,transition:"easeOutElastic"});
		}
		private function deRotateThumb(e:MouseEvent):void {
			Tweener.addTween(e.target,{alpha:.6,time:.01,transition:"easeInExpo"});
			Tweener.addTween(e.target,{scaleX:1,time:1,transition:"easeOutElastic"});
			Tweener.addTween(e.target,{scaleY:1,time:1,transition:"easeOutElastic"});
		}
		private function thumbSoundPlay(e:MouseEvent):void {
			thumbSound.play();
		}
		private function onBallGrab(Event:MouseEvent):void {
			scroller.scrolling = true;
			scroller.trackBall.startDrag(false, scroller.scrollBoundary);
		}
		private function onBallLoose(Event:MouseEvent):void {
			scroller.scrolling = false;
			scroller.trackBall.stopDrag();
		}
		private function enterHandler (e:Event):void {
			if(scroller.scrolling == true) {
				descriptionField.projectDescription.scrollV = Math.round(((scroller.trackBall.y - scroller.scrollBoundary.y)/103) * descriptionField.projectDescription.maxScrollV);
			}
		}
		private function displayPercent (e:ProgressEvent):void {
			var perc:Number = e.bytesLoaded / e.bytesTotal;
			
			with(_percentInFormat) {
				size = 40;
				font = _gillSans.fontName;
				color = 0x516275;
			}
			with(_percentInField) {
				x = 710;
				y = 200;
				embedFonts = true;
				autoSize = TextFieldAutoSize.CENTER;
				_percentInField.text = Math.ceil(perc*100).toString() + "%";
			}
			addChild(_percentInField);
			_percentInField.setTextFormat(_percentInFormat);
		}
		private function loaderOut(e:Event):void {
			removeChild(_percentInField);
		}
		private function haltScroll(e:Event):void {
			if(mouseY < 0 || mouseY > 510) {
				scroller.scrolling = false;
				scroller.trackBall.stopDrag();
			}
		}
	}
}